/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2015. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
dojo.provide("com.ibm.rdm.web.notifications.EventTopics");

com.ibm.rdm.web.notifications.EventTopics = {
	///////////////////////////////////////////////////////////////////////////////////
	// PUBLIC FIELDS

	RESOURCE_CREATED: "com.ibm.rdm.web.notifications.EventTopics.RESOURCE_CREATED",
	RESOURCE_DELETED: "com.ibm.rdm.web.notifications.EventTopics.RESOURCE_DELETED",
	RESOURCE_CHANGED: "com.ibm.rdm.web.notifications.EventTopics.RESOURCE_CHANGED",
	RESOURCE_MOVED: "com.ibm.rdm.web.notifications.EventTopics.RESOURCE_MOVED",
	RESOURCE_RENAMED: "com.ibm.rdm.web.notifications.EventTopics.RESOURCE_RENAMED",
	RESOURCE_PROCESS_AREA_CHANGED: "com.ibm.rdm.web.notifications.EventTopics.RESOURCE_PROCESS_AREA_CHANGED",
	RESOURCE_COPIED: "com.ibm.rdm.web.notifications.EventTopics.RESOURCE_COPIED",
	RESOURCES_COPIED: "com.ibm.rdm.web.notifications.EventTopics.RESOURCES_COPIED",
	
	LINK_TYPE_UPDATED: "com.ibm.rdm.web.notifications.EventTopics.LINK_TYPE_UPDATED",
	LINK_TYPE_REMOVED: "com.ibm.rdm.web.notifications.EventTopics.LINK_TYPE_REMOVED",
	LINK_TYPE_ADDED: "com.ibm.rdm.web.notifications.EventTopics.LINK_TYPE_ADDED",

	LINK_PREFERENCES_UPDATED: "com.ibm.rdm.web.notifications.EventTopics.LINK_PREFERENCES_UPDATED",
	LINK_CONSTRAINTS_UPDATED: "com.ibm.rdm.web.notifications.EventTopics.LINK_CONSTRAINTS_UPDATED",
	
	LINK_VALIDITY_UPDATED: "com.ibm.rdm.web.notifications.EventTopics.LINK_VALIDITY_UPDATED",
	LINK_VALIDITY_ROLLUP_UPDATED: "com.ibm.rdm.web.notifications.EventTopics.LINK_VALIDITY_ROLLUP_UPDATED",
	LINKS_EXPLORER_VALIDITY_STATUS_UPDATED: "com.ibm.rdm.web.notifications.EventTopics.LINKS_EXPLORER_VALIDITY_STATUS_UPDATED",
	
	// signal when requirement viewer changes to the edit and view modes
	ARTIFACT_EDIT_MODE: "com.ibm.rdm.web.notifications.EventTopics.ARTIFACT_EDIT_MODE",
	ARTIFACT_VIEW_MODE: "com.ibm.rdm.web.notifications.EventTopics.ARTIFACT_VIEW_MODE",
	ARTIFACT_SAVED: "com.ibm.rdm.web.notifications.EventTopics.ARTIFACT_SAVED",
	
	EDIT_STARTED: "com.ibm.rdm.web.notifications.EventTopics.EDIT_STARTED",
	EDIT_FINISHED: "com.ibm.rdm.web.notifications.EventTopics.EDIT_FINISHED",
	
	TAG_ADDED: "com.ibm.rdm.web.notifications.EventTopics.TAG_ADDED",
	TAG_DELETED: "com.ibm.rdm.web.notifications.EventTopics.TAG_DELETED",
	TAG_EDITED: "com.ibm.rdm.web.notifications.EventTopics.TAG_EDITED",
	TAG_ARTIFACTS_UPDATED: "com.ibm.rdm.web.notifications.EventTopics.TAG_ARTIFACTS_UPDATED", // For tags applied to an artifact

	FOLDER_MOVED: "com.ibm.rdm.web.notifications.EventTopics.FOLDER_MOVED",
	FOLDER_DELETED: "com.ibm.rdm.web.notifications.EventTopics.FOLDER_DELETED",
	FOLDER_RENAMED: "com.ibm.rdm.web.notifications.EventTopics.FOLDER_RENAMED",
	FOLDER_CREATED: "com.ibm.rdm.web.notifications.EventTopics.FOLDER_CREATED",
	FOLDER_SELECTED: "com.ibm.rdm.web.notifications.EventTopics.FOLDER_SELECTED",
	FOLDER_PROCESS_AREA_CHANGED: "com.ibm.rdm.web.notifications.EventTopics.FOLDER_PROCESS_AREA_CHANGED",
	FOLDER_CONTENTS_CHANGED: "com.ibm.rdm.web.notifications.EventTopics.FOLDER_CONTENTS_CHANGED",
	
	OBJECT_TYPE_CREATED: "com.ibm.rdm.web.notifications.EventTopics.OBJECT_TYPE_CREATED",
	OBJECT_TYPE_CHANGED: "com.ibm.rdm.web.notifications.EventTopics.OBJECT_TYPE_CHANGED",
	OBJECT_TYPE_DELETED: "com.ibm.rdm.web.notifications.EventTopics.OBJECT_TYPE_DELETED",
	
	ATTRIBUTE_DEFINITION_CREATED: "com.ibm.rdm.web.notifications.EventTopics.ATTRIBUTE_DEFINITION_CREATED",
	ATTRIBUTE_DEFINITION_CHANGED: "com.ibm.rdm.web.notifications.EventTopics.ATTRIBUTE_DEFINITION_CHANGED",
	ATTRIBUTE_DEFINITION_DELETED: "com.ibm.rdm.web.notifications.EventTopics.ATTRIBUTE_DEFINITION_DELETED",
	
	ATTRIBUTE_TYPE_CREATED: "com.ibm.rdm.web.notifications.EventTopics.ATTRIBUTE_TYPE_CREATED",
	ATTRIBUTE_TYPE_CHANGED: "com.ibm.rdm.web.notifications.EventTopics.ATTRIBUTE_TYPE_CHANGED",
	ATTRIBUTE_TYPE_DELETED: "com.ibm.rdm.web.notifications.EventTopics.ATTRIBUTE_TYPE_DELETED",
	
	PAGE_DEFINITION_CHANGE: "com.ibm.rdm.web.notifications.EventTopics.PAGE_DEFINITION_CHANGE",
	PAGE_NUMBER_CHANGE: "com.ibm.rdm.web.notifications.EventTopics.PAGE_NUMBER_CHANGE",
	
	FILTER_ADDED: "com.ibm.rdm.web.notifications.EventTopics.FILTER_ADDED",
	FILTER_DELETED: "com.ibm.rdm.web.notifications.EventTopics.FILTER_DELETED",
	FILTER_EDITED: "com.ibm.rdm.web.notifications.EventTopics.FILTER_EDITED",
	
	LINK_CREATED: "com.ibm.rdm.web.notifications.EventTopics.LINK_CREATED",
	LINK_CHANGED: "com.ibm.rdm.web.notifications.EventTopics.LINK_CHANGED",
	LINK_DELETED: "com.ibm.rdm.web.notifications.EventTopics.LINK_DELETED",
	DM_LINK_ACTIONS: "com.ibm.rdm.web.notifications.EventTopics.DM_LINK_ACTIONS",
	LINK_IN_COLLECTION_CREATED: "com.ibm.rdm.web.notifications.EventTopics.LINK_IN_COLLECTION_CREATED",
	
	BANNER_UPDATE: "com.ibm.rdm.web.notifications.EventTopics.BANNER_UPDATE",
	
	PROJECT_CREATED: "com.ibm.rdm.web.notifications.EventTopics.PROJECT_CREATED",
	PROJECT_DELETED: "com.ibm.rdm.web.notifications.EventTopics.PROJECT_DELETED",
	PROJECT_MODIFIED: "com.ibm.rdm.web.notifications.EventTopics.PROJECT_MODIFIED",
	
	ELEMENT_SELECTED: "com.ibm.rdm.web.notifications.EventTopics.ELEMENT_SELECTED",
	ELEMENT_CACHE_UPDATED: "com.ibm.rdm.web.notifications.EventTopics.ELEMENT_CACHE_UPDATED",

	// ARTIFACT_TEMPLATES_UPDATED: String
	//		This event is published whenever an artifact template is
	//		created, changed or deleted or the user clicks on the header's
	//      refresh button when in the project dashboard.
	INVALIDATE_CACHED_ARTIFACT_TEMPLATES: "com.ibm.rdm.web.notifications.EventTopics.INVALIDATE_CACHED_ARTIFACT_TEMPLATES",
	
	MODULE_STRUCTURE_CHANGED: "com.ibm.rdm.web.notifications.EventTopics.MODULE_STRUCTURE_CHANGED",
	MODULE_COUNT_CHANGED: "com.ibm.rdm.web.notifications.EventTopics.MODULE_COUNT_CHANGED",
	// Raised by the virtual grid to indicate that rows have been reconciled to account for a structural change. 
	MODULE_GRID_RECONCILED: "com.ibm.rdm.web.notifications.EventTopics.MODULE_GRID_RECONCILED",

	ABOUT_TO_CHANGE_VIEW: "com.ibm.rdm.web.notifications.EventTopics.ABOUT_TO_CHANGE_VIEW",

	GRID_COLUMNS_MODIFIED: "com.ibm.rdm.web.notifications.EventTopics.GRID_COLUMNS_MODIFIED",
	GRID_GROUP_BY_MODIFIED: "com.ibm.rdm.web.notifications.EventTopics.GRID_GROUP_BY_MODIFIED",
	GRID_LINK_EXPANSION_MODIFIED: "com.ibm.rdm.web.notifications.EventTopics.GRID_LINK_EXPANSION_MODIFIED",
	GRID_HIERARCHY_LEVEL_MODIFIED: "com.ibm.rdm.web.notifications.EventTopics.GRID_HIERARCHY_LEVEL_MODIFIED",

	ARTIFACT_SHOW_BASE_PROPERTIES: "com.ibm.rdm.web.notifications.EventTopics.ARTIFACT_SHOW_BASE_PROPERTIES",
	MODULE_CONTENTS_POPULATED: "com.ibm.rdm.web.notifications.EventTopics.MODULE_CONTENTS_POPULATED",
	COMMENTS_CHANGED: "com.ibm.rdm.web.notifications.EventTopics.COMMENTS_CHANGED",
	
	BASELINE_DELETED: "com.ibm.rdm.web.notifications.EventTopics.BASELINE_DELETED",

	REVIEW_CREATED: "com.ibm.rdm.web.notifications.EventTopics.REVIEW_CREATED",
	REVIEW_DELETED: "com.ibm.rdm.web.notifications.EventTopics.REVIEW_DELETED",

	DRAG_ENDED: "com.ibm.rdm.web.notifications.EventTopics.DRAG_ENDED",
	
	// notifies that an artifact's merge state has changed.
	MERGE_STATE_CHANGE: "com.ibm.rdm.web.notifications.EventTopics.MERGE_STATE_CHANGE",
	MERGE_STATE_CHANGE_ATTRIBUTE: "com.ibm.rdm.web.notifications.EventTopics.MERGE_STATE_CHANGE_ATTRIBUTE",

	ARTIFACT_SIDEBAR_TOGGLED: "com.ibm.rdm.web.notifications.EventTopics.ARTIFACT_SIDEBAR_TOGGLED",
	ABOUT_TO_TOGGLE_SIDEBARS: "com.ibm.rdm.web.notifications.EventTopics.ABOUT_TO_TOGGLE_SIDEBARS",

	USER_PROMPTS_RESTORED: "com.ibm.rdm.web.notifications.EventTopics.USER_PROMPTS_RESTORED",

	CLOSE_SPLITTERS : "com.ibm.rdm.web.notifications.EventTopics.CLOSE_SPLITTERS",
	
	// This event is fired before the Virtual Grid measures it's pages, typically it's used so that
	// a control that displays a grid can remember the current top visible item if it wants to and
	// then scroll it back into view, if there is a height change.
	GRID_PRE_PAGE_HEIGHT_RECALCULATE: "com.ibm.rdm.web.notifications.EventTopics.GRID_PRE_PAGE_HEIGHT_RECALCULATE",
	
	// Event indicates the page height is changed.
	GRID_PAGE_HEIGHT_CHANGE: "com.ibm.rdm.web.notifications.EventTopics.GRID_PAGE_HEIGHT_CHANGE",
	
	// Fired after the view has been updated following column addition or rearrangement.
	MODULE_COLUMN_CHANGE: "com.ibm.rdm.web.notifications.EventTopics.MODULE_COLUMN_CHANGE",
	// notifies that the current configuration has changed.
	CURRENT_CONFIGURATION_CHANGED: "com.ibm.rdm.web.notifications.EventTopics.CURRENT_CONFIGURATION_CHANGED",
	
	// notifies to re-scroll the GoTo item if any back to the view and set the item as the top item in the viewport
	RESET_GOTO_ITEM: "com.ibm.rdm.web.notifications.EventTopics.RESET_GOTO_ITEM",
	RESET_GOTO_ITEM_AT_IMG_LOADED: "com.ibm.rdm.web.notifications.EventTopics.RESET_GOTO_ITEM_AT_IMG_LOADED",
	
	// notifies to repaint the link line in link explorer if it contains OSLC links
	REPAINT_LINK_LINE: "com.ibm.rdm.web.notifications.EventTopics.REPAINT_LINK_LINE",
	
	// notifies that the user choose to show or hide the pencil menus
	HIDE_PENCIL_MENU_USER_PREF: "com.ibm.rdm.web.notifications.EventTopics.HIDE_PENCIL_MENU_USER_PREF"
		
};

})();
